zoukankan      html  css  js  c++  java
  • Codeforces Round #238 (Div. 2) D. Toy Sum 暴搜

    题目链接:

    题目

    D. Toy Sum
    time limit per test:1 second
    memory limit per test:256 megabytes

    问题描述

    Little Chris is very keen on his toy blocks. His teacher, however, wants Chris to solve more problems, so he decided to play a trick on Chris.

    There are exactly s blocks in Chris's set, each block has a unique number from 1 to s. Chris's teacher picks a subset of blocks X and keeps it to himself. He will give them back only if Chris can pick such a non-empty subset Y from the remaining blocks, that the equality holds:

    "Are you kidding me?", asks Chris.
    For example, consider a case where s = 8 and Chris's teacher took the blocks with numbers 1, 4 and 5. One way for Chris to choose a set is to pick the blocks with numbers 3 and 6, see figure. Then the required sums would be equal: (1 - 1) + (4 - 1) + (5 - 1) = (8 - 3) + (8 - 6) = 7.

    However, now Chris has exactly s = 106 blocks. Given the set X of blocks his teacher chooses, help Chris to find the required set Y!

    输入

    The first line of input contains a single integer n (1 ≤ n ≤ 5·105), the number of blocks in the set X. The next line contains n distinct space-separated integers x1, x2, ..., xn (1 ≤ xi ≤ 106), the numbers of the blocks in X.
    Note: since the size of the input and output could be very large, don't use slow output techniques in your language. For example, do not use input and output streams (cin, cout) in C++.

    输出

    In the first line of output print a single integer m (1 ≤ m ≤ 106 - n), the number of blocks in the set Y. In the next line output m distinct space-separated integers y1, y2, ..., ym (1 ≤ yi ≤ 106), such that the required equality holds. The sets X and Y should not intersect, i.e. xi ≠ yj for all i, j (1 ≤ i ≤ n; 1 ≤ j ≤ m). It is guaranteed that at least one solution always exists. If there are multiple solutions, output any of them.

    样例

    input
    3
    1 4 5

    output
    2
    999993 1000000

    input
    1
    1
    output
    1
    1000000

    题意

    给你一个大小为n的X集合x1,x2,...,xn,问你能不能选定一个集合大小S(S<=10^6),使得从S包含X,并且从属于S但不属于X的元素组成的集合里,选出一个大小为k的非空子集Y,使得等式sigma(xi-1)==sigma(s-yj),其中1<=i<=n,1<=j<=k。

    题解

    1、暴搜,在属于S但不属于X的元素组成的集合里暴搜出一个满足答案的解。跑了717ms。(暴搜方案,每个数选或不选)

    #include<iostream>
    #include<cstdio>
    #include<map>
    #include<vector>
    #include<algorithm>
    using namespace std;
    
    typedef __int64 LL;
    const int maxn=5e5+10;
    const int INF=1e6;
    
    int arr[maxn];
    int n;
    map<int,int> mp; 
    vector<int> ans;
    vector<int> re;
    
    bool dfs(int cur,LL sum){
    	if(sum==0) return true;
    	int pos=lower_bound(re.begin(),re.end(),sum)-re.begin();
    	if(pos>cur) pos=cur;
    	if(pos<=0) return false;
    	ans.push_back(INF-re[pos]);
    	if(dfs(pos-1,sum-re[pos])) return true;
    	ans.pop_back(); 
    	if(dfs(pos-1,sum)) return true;
    	return false;
    }
    
    int main(){
    	scanf("%d",&n);
    	LL sum=0;
    	for(int i=0;i<n;i++){
    		int x; scanf("%d",&x); mp[x]=1;
    		sum+=x-1;
    	}
    	re.clear();
    	re.push_back(-1); 
    	for(int i=1;i<=INF;i++){ 
    		if(!mp[i]){
    			re.push_back(INF-i);
    		}
    	}
    	sort(re.begin(),re.end());
    	dfs(re.size()-1,sum);
    	if(!mp[INF]) ans.push_back(INF);
    	printf("%d
    ",ans.size());
    	for(int i=0;i<ans.size()-1;i++) printf("%d ",ans[i]);
    	printf("%d
    ",ans[ans.size()-1]);
    	return 0;
    }
    

    2、找对称的数,对于x,有y=S+1-i,使得x-1=S-y;所以对于xi,如果与它对称的数yi不在X里面,则吧yi放到答案里面,如果在,则这两个数相加为S,我们只要另找一个数不在X里面,并且它对称的数也不在X里面,然后吧这两个数都加到答案里面就可以了。

    #include<iostream>
    #include<vector>
    #include<cstdio>
    #include<algorithm>
    #include<cstring>
    using namespace std;
    
    const int maxn = 1e6 + 10;
    const int S = 1e6;
    
    int used[maxn];
    
    int main() {
    	memset(used, 0, sizeof(used));
    	int n;
    	scanf("%d", &n);
    	for (int i = 0; i < n; i++) {
    		int x; scanf("%d", &x); used[x] = 1;
    	}
    	vector<int> ans;
    	//cnt统计一个数和与它对称的数都在X里面的数对
    	int cnt = 0;
    	for (int i = 1; i <= S; i++) {
    		if (used[i]) {
    			int j = S + 1 - i;
    			if (!used[j]) {
    				ans.push_back(j);
    				used[j] = 1;
    			}
    			else {
    				if(i<=j) cnt++;
    			}
    		}
    	}
    	for (int i = 1; i <= S&&cnt>0; i++) {
    		if (!used[i]) {
    			int j = S + 1 - i;
    			ans.push_back(i);
    			ans.push_back(j);
    			used[i] = used[j] = 1;
    			cnt--;
    		}
    	}
    	sort(ans.begin(), ans.end());
    	printf("%d
    ", ans.size());
    	for (int i = 0; i < ans.size() - 1; i++) printf("%d ", ans[i]);
    	printf("%d
    ",ans[ans.size()-1]);
    	return 0;
    }
  • 相关阅读:
    DS博客作业02--栈和队列
    DS博客作业01--线性表
    c博客06-结构体&文件
    C博客作业05--指针
    C语言博客作业04--数组
    C语言博客作业03--函数
    JAVA面向对象设计大作业——QQ联系人系统
    DS博客作业05--查找
    DS博客作业04--图
    DS博客作业03--树
  • 原文地址:https://www.cnblogs.com/fenice/p/5678398.html
Copyright © 2011-2022 走看看